# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .remote_data import RemoteData
from .tax_rate_company import TaxRateCompany


class TaxRate(pydantic_v1.BaseModel):
    """
    # The TaxRate Object

    ### Description

    The `TaxRate` object is used to represent a tax rate.

    ### Usage Example

    Fetch from the `LIST TaxRates` endpoint and view tax rates relevant to a company.
    """

    id: typing.Optional[str]
    remote_id: typing.Optional[str] = pydantic_v1.Field()
    """
    The third-party API ID of the matching object.
    """

    created_at: typing.Optional[dt.datetime] = pydantic_v1.Field()
    """
    The datetime that this object was created by Merge.
    """

    modified_at: typing.Optional[dt.datetime] = pydantic_v1.Field()
    """
    The datetime that this object was modified by Merge.
    """

    description: typing.Optional[str] = pydantic_v1.Field()
    """
    The tax rate's description.
    """

    total_tax_rate: typing.Optional[float] = pydantic_v1.Field()
    """
    The tax’s total tax rate - sum of the tax components (not compounded).
    """

    effective_tax_rate: typing.Optional[float] = pydantic_v1.Field()
    """
    The tax rate’s effective tax rate - total amount of tax with compounding.
    """

    company: typing.Optional[TaxRateCompany] = pydantic_v1.Field()
    """
    The subsidiary that the tax rate belongs to (in the case of multi-entity systems).
    """

    remote_was_deleted: typing.Optional[bool] = pydantic_v1.Field()
    """
    Indicates whether or not this object has been deleted in the third party platform.
    """

    field_mappings: typing.Optional[typing.Dict[str, typing.Any]]
    remote_data: typing.Optional[typing.List[RemoteData]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.forbid
        json_encoders = {dt.datetime: serialize_datetime}
