# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .address_request import AddressRequest
from .contact_request_account import ContactRequestAccount
from .contact_request_owner import ContactRequestOwner
from .email_address_request import EmailAddressRequest
from .phone_number_request import PhoneNumberRequest
from .remote_field_request import RemoteFieldRequest


class ContactRequest(pydantic_v1.BaseModel):
    """
    # The Contact Object

    ### Description

    The `Contact` object is used to represent an existing point of contact at a company in a CRM system.

    ### Usage Example

    TODO
    """

    first_name: typing.Optional[str] = pydantic_v1.Field()
    """
    The contact's first name.
    """

    last_name: typing.Optional[str] = pydantic_v1.Field()
    """
    The contact's last name.
    """

    account: typing.Optional[ContactRequestAccount] = pydantic_v1.Field()
    """
    The contact's account.
    """

    owner: typing.Optional[ContactRequestOwner] = pydantic_v1.Field()
    """
    The contact's owner.
    """

    addresses: typing.Optional[typing.List[AddressRequest]]
    email_addresses: typing.Optional[typing.List[EmailAddressRequest]]
    phone_numbers: typing.Optional[typing.List[PhoneNumberRequest]]
    last_activity_at: typing.Optional[dt.datetime] = pydantic_v1.Field()
    """
    When the contact's last activity occurred.
    """

    integration_params: typing.Optional[typing.Dict[str, typing.Any]]
    linked_account_params: typing.Optional[typing.Dict[str, typing.Any]]
    remote_fields: typing.Optional[typing.List[RemoteFieldRequest]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.forbid
        json_encoders = {dt.datetime: serialize_datetime}
