# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .employer_benefit_benefit_plan_type import EmployerBenefitBenefitPlanType


class EmployerBenefit(pydantic_v1.BaseModel):
    """
    # The EmployerBenefit Object

    ### Description

    The `Employer Benefit` object is used to represent a benefit plan offered by a company.

    ### Usage Example

    Fetch from the `LIST EmployerBenefits` endpoint and filter by `ID` to show all EmployerBenefits.
    """

    id: typing.Optional[str]
    remote_id: typing.Optional[str] = pydantic_v1.Field()
    """
    The third-party API ID of the matching object.
    """

    created_at: typing.Optional[dt.datetime] = pydantic_v1.Field()
    """
    The datetime that this object was created by Merge.
    """

    modified_at: typing.Optional[dt.datetime] = pydantic_v1.Field()
    """
    The datetime that this object was modified by Merge.
    """

    benefit_plan_type: typing.Optional[EmployerBenefitBenefitPlanType] = pydantic_v1.Field()
    """
    The type of benefit plan.
    
    - `MEDICAL` - MEDICAL
    - `HEALTH_SAVINGS` - HEALTH_SAVINGS
    - `INSURANCE` - INSURANCE
    - `RETIREMENT` - RETIREMENT
    - `OTHER` - OTHER
    """

    name: typing.Optional[str] = pydantic_v1.Field()
    """
    The employer benefit's name - typically the carrier or network name.
    """

    description: typing.Optional[str] = pydantic_v1.Field()
    """
    The employer benefit's description.
    """

    deduction_code: typing.Optional[str] = pydantic_v1.Field()
    """
    The employer benefit's deduction code.
    """

    remote_was_deleted: typing.Optional[bool] = pydantic_v1.Field()
    """
    Indicates whether or not this object has been deleted in the third party platform.
    """

    field_mappings: typing.Optional[typing.Dict[str, typing.Any]]
    remote_data: typing.Optional[typing.List[typing.Optional[typing.Dict[str, typing.Any]]]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.forbid
        json_encoders = {dt.datetime: serialize_datetime}
