# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .contact_request_account import ContactRequestAccount


class ContactRequest(pydantic_v1.BaseModel):
    """
    # The Contact Object

    ### Description

    The `Contact` object is used to represent the customer, lead, or external user that a ticket is associated with.

    ### Usage Example

    TODO
    """

    name: typing.Optional[str] = pydantic_v1.Field()
    """
    The contact's name.
    """

    email_address: typing.Optional[str] = pydantic_v1.Field()
    """
    The contact's email address.
    """

    phone_number: typing.Optional[str] = pydantic_v1.Field()
    """
    The contact's phone number.
    """

    details: typing.Optional[str] = pydantic_v1.Field()
    """
    The contact's details.
    """

    account: typing.Optional[ContactRequestAccount] = pydantic_v1.Field()
    """
    The contact's account.
    """

    integration_params: typing.Optional[typing.Dict[str, typing.Any]]
    linked_account_params: typing.Optional[typing.Dict[str, typing.Any]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.forbid
        json_encoders = {dt.datetime: serialize_datetime}
